//
//      Sound/Timer engine wrappers for Midas-unsupported OS
//


#include <unistd.h>     // This is for sleep, in the timer check routine
#include <stdlib.h>     // atexit(), random
#include <string.h>     // String splicing routines

#include "ithelib.h"
#include "sound.hpp"    // Us

// defines

#define TIMER_INT 8     // Reprogram int 8
#define QUEUE_RATE 32   // Refresh sound queue every 32 clock cycles

// variables

extern char mus_chan;                      // Number of music channels
extern char sfx_chan;                      // Number of effects channels
extern int  driftlevel;                    // Amount of frequency variation

int sf_volume = 63;
static int mu_volume = 0;

static char string[32];    // For string splicing
static char T_Running=0;   // Is the timer running?
static char S_Running=0;   // Is the sound running?
int Songs=0;
int Waves=0;
static int pausedata=0;   // Speed of song before pausing, 0 if not paused
static int cursong=-1;

struct SMTab *wavtab;       // Tables of data for each sound and song.
struct SMTab *modtab;       // Filled by script.cc

// functions

void S_Init();              // Set up sound device
void S_Load();              // Load the sound and music
void S_Start();             // Start the mixing kernel
void S_Term();              // Stop the mixing kernel and shut down
void S_SoundVolume();       // Set the Sound volume
void S_MusicVolume();       // Set the Music volume
void S_PlaySample(char *s,int v);   // Play a sound sample
void S_PlayModule(int s);   // Play a music module
void S_StopModule();        // Stop the music
char S_Sync();              // Make sure the timer is working

//static void S_Tickhandler(void); // Mixer refresh
static void LoadMods();
static void LoadWavs();
static int  GetWavFreq(FILE *fp);               // Get frequency


// Public code

/*
 *      S_Init - Load in the soundcard settings and set up the device
 */

void S_Init()
{
if(S_Running)          // Safety valve
    return;

// Announce the sound library

ilog_printf("S_Init()\n");
ilog_printf("  Bugger-all sound system initialising...\n");

ilog_printf("  Init successful\n");

S_Running=1;                    // Right! Let's go...
}


/*
 *      S_Start - Start the actual 'sound' output
 */

void S_Start()
{
ilog_printf("S_Start()\n");

//mp_volume = 100;
}


/*
 *      S_Term - Stop the sound process
 */

void S_Term()
{
if(!S_Running)          // Safety valve
    return;

ilog_printf("S_Term()\n");

S_Running=0;            // We could actually restart the system now
ilog_printf("runstop\n");
}


/*
 *      S_Load - Load in the music and samples.
 */

void S_Load()
{
ilog_printf("S_Load()\n");
}


/*
 *      S_MusicVolume - Set the music level
 */

void S_MusicVolume(int vol)
{
return;
}


/*
 *      S_SoundVolume - Set the effects level
 */

void S_SoundVolume(int vol)
{
return;
}


/*
 *   S_PlayModule - play a music module from the array song[]
 *                  may disrupt the sound effects slightly
 */

void S_PlayModule(char *name)
{
return;
}

/*
 *   S_PauseModule - Stop music, not SFX
 */

void S_PauseModule()
{
return;
}

/*
 *   S_UnPauseModule - Restart music
 */

void S_UnPauseModule()
{
return;
}

/*
 *   S_PlaySample - play a sound sample.
 */

void S_PlaySample(char *name, int v)
{
return;
}



